﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadControlsWinFormsApp.Q12011.New
{
    public partial class A_RadWizardDemo : Telerik.WinControls.UI.RadForm
    {
        private bool useWelcomeDialog;

        public bool UseWelcomePage { get; set; }

        public A_RadWizardDemo(bool useWelcomePage)
        {
            UseWelcomePage = useWelcomePage;
            InitializeComponent();
            if (!UseWelcomePage)
            {
                radWizard1.SelectedPage = radWizard1.Pages[1];
                radProgressBar1.Maximum = radWizard1.Pages.Count - 2;
            }
            else
            {
                radProgressBar1.Maximum = radWizard1.Pages.Count - 1;
            }
        }

        private void radWizard1_SelectedPageChanging(object sender, Telerik.WinControls.UI.SelectedPageChangingEventArgs e)
        {
            if (chkShowPageEvents.Checked)
            {
                DialogResult userChoice = MessageBox.Show("Selected Page Changing", "Page Changing", MessageBoxButtons.OKCancel);
                if (DialogResult.Cancel == userChoice)
                {
                    e.Cancel = true;
                }
            }
        }

        private void radWizard1_Next(
                                     object sender,
                                     Telerik.WinControls.UI.WizardCancelEventArgs e)
        {
            if (radWizard1.SelectedPage == radWizard1.Pages[1])
            {
                if (!rbThing1.IsChecked && !rbThing2.IsChecked)
                {
                    MessageBox.Show("Please Select Thing1 Or Thing2");
                    e.Cancel = true;
                }
            }
            if (chkShowPageEvents.Checked)
            {
                DialogResult userChoice = MessageBox.Show("Next Clicked", "Next", MessageBoxButtons.OKCancel);
                if (DialogResult.Cancel == userChoice)
                {
                    e.Cancel = true;
                }
            }
        }

        private void radWizard1_Cancel(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void radWizard1_Finish(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            UseWelcomePage = !chkHideWelcome.Checked;
            this.Close();
        }

        private void radWizard1_Previous(
                                         object sender,
                                         Telerik.WinControls.UI.WizardCancelEventArgs e)
        {
            if (chkShowPageEvents.Checked)
            {
                DialogResult userChoice = MessageBox.Show("Previous Clicked", "Previous", MessageBoxButtons.OKCancel);
                if (DialogResult.Cancel == userChoice)
                {
                    e.Cancel = true;
                }
            }
        }

        private void radWizard1_SelectedPageChanged(
                                                    object sender,
                                                    Telerik.WinControls.UI.SelectedPageChangedEventArgs e)
        {
            if (e.SelectedPage == radWizard1.WelcomePage && !UseWelcomePage)
            {
                UseWelcomePage = true;
                chkHideWelcome.Checked = false;
                radProgressBar1.Maximum = radWizard1.Pages.Count - 1;
            }
            int index = radWizard1.Pages.IndexOf(radWizard1.SelectedPage);
            radProgressBar1.Value1 = (UseWelcomePage) ? index : index - 1;
            if (chkShowPageEvents.Checked)
            {
                var message = string.Format("Previous Page:{0}\r\nCurrent Page:{1}", e.PreviousPage.Title, e.SelectedPage.Title);
                MessageBox.Show(message);
            }
            if (e.SelectedPage == radWizard1.Pages[radWizard1.Pages.Count - 1])
            {
                StringBuilder sb = new StringBuilder("Thing");
                if (rbThing1.IsChecked)
                {
                    sb.Append("1");
                }
                else
                {
                    sb.Append("2");
                }
                sb.Append(" will have ");
                if (chkGreenEggs.Checked && chkHam.Checked)
                {
                    sb.Append("Green Eggs and Ham");
                }
                else
                {
                    if (!chkGreenEggs.Checked && !chkHam.Checked)
                    {
                        sb.Append("nothing.");
                    }
                    else
                    {
                        if (chkGreenEggs.Checked)
                        {
                            sb.Append("Green Eggs.");
                        }
                        else
                        {
                            sb.Append("Ham.");
                        }
                    }
                }
                lblSummary.Text = sb.ToString();
            }
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Hello");
        }

        private void radWizard1_Help(object sender, EventArgs e)
        {
            MessageBox.Show("Help Was Clicked");
        }

        private void rbThing_ToggleStateChanged(object sender, Telerik.WinControls.UI.StateChangedEventArgs args)
        {
            txtPersonLabel.Text = (sender as RadRadioButton).Text + " Will Have:";
        }
    }
}