﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadControlsWinFormsApp.Q12011.Updated
{
    public partial class B_RadSchedulerDemo : Telerik.WinControls.UI.RadForm
    {
        public B_RadSchedulerDemo()
        {
            InitializeComponent();
            foreach (var viewType in Enum.GetValues(typeof(SchedulerViewType)))
            {
                if (viewType.ToString() != "MultiDay")
                {
                    RadListDataItem di = new RadListDataItem();
                    di.Text = viewType.ToString();
                    di.Value = viewType;
                    ddlActiveViewType.Items.Add(di);
                }
            }
            foreach (ScaleRange range in Enum.GetValues(typeof(ScaleRange)))
            {
                RadListDataItem item = new RadListDataItem();
                item.Text = range.ToString();
                item.Value = range;
                ddlScale.Items.Add(item);
            }
            for (int i = 1; i < 10; i++)
            {
                RadListDataItem item = new RadListDataItem();
                item.Text = i.ToString();
                item.Value = i;
                ddlCount.Items.Add(item);
            }
            ddlCount.SelectedIndex = 0;
            ddlScale.SelectedIndex = 4;
            ddlActiveViewType.SelectedIndex = 0;
        }

        private void ddlScale_SelectedIndexChanged(object sender, Telerik.WinControls.UI.Data.PositionChangedEventArgs e)
        {
            RadDropDownListElement dropDownList = sender as RadDropDownListElement;
            ScaleRange range = (ScaleRange)(dropDownList.SelectedValue);
            // set the appropriate range factor based on the type of view
            switch (radScheduler1.ActiveViewType)
            {
                case SchedulerViewType.Day:
                    
                    SchedulerDayView schedulerDayView = 
                        radScheduler1.ActiveView as SchedulerDayView;
                    schedulerDayView.RangeFactor = range;
                    break;
                case SchedulerViewType.MultiDay:
                    SchedulerMultiDayView schedulerMultiDayView = radScheduler1.ActiveView as SchedulerMultiDayView;
                    schedulerMultiDayView.RangeFactor = range;
                    break;
                case SchedulerViewType.Week:
                case SchedulerViewType.WorkWeek:
                    SchedulerWeekView schedulerWeekView = radScheduler1.ActiveView as SchedulerWeekView;
                    schedulerWeekView.RangeFactor = range;
                    break;
            }

        }

        private void ddlActiveViewType_SelectedIndexChanged(object sender, Telerik.WinControls.UI.Data.PositionChangedEventArgs e)
        {
            RadDropDownListElement dropDownList = sender as RadDropDownListElement;
            radScheduler1.ActiveViewType = (SchedulerViewType)(dropDownList.SelectedValue);
            switch (radScheduler1.ActiveViewType)
            {
                case SchedulerViewType.Day:

                    SchedulerDayView schedulerDayView =
                        radScheduler1.ActiveView as SchedulerDayView;
                    schedulerDayView.DayCount = 1;
                    break;
                case SchedulerViewType.MultiDay:
                    SchedulerMultiDayView schedulerMultiDayView = radScheduler1.ActiveView as SchedulerMultiDayView;
                    schedulerMultiDayView.DayCount = 3;
                    break;
                case SchedulerViewType.Week:
                case SchedulerViewType.WorkWeek:
                    SchedulerWeekView schedulerWeekView = radScheduler1.ActiveView as SchedulerWeekView;
                    schedulerWeekView.DayCount = 7;
                    break;
                case SchedulerViewType.Month:
                    SchedulerMonthView schedulerMonthView = radScheduler1.ActiveView as SchedulerMonthView;
                    schedulerMonthView.WeekCount = 3;
                    break;
            }

        }

        private void ddlCount_SelectedValueChanged(object sender, Telerik.WinControls.UI.Data.ValueChangedEventArgs e)
        {
            RadDropDownListElement dropDownList = sender as RadDropDownListElement;
            int count = (int)dropDownList.SelectedValue;
            // set the Day or WeekCount based on the current view
            switch (radScheduler1.ActiveViewType)
            {
                case SchedulerViewType.Day:
                    (radScheduler1.ActiveView as SchedulerDayView).DayCount = count;
                    break;
                case SchedulerViewType.MultiDay:
                    (radScheduler1.ActiveView as SchedulerMultiDayView).DayCount = count;
                    break;
                case SchedulerViewType.Month:
                    (radScheduler1.ActiveView as SchedulerMonthView).WeekCount = count;
                    break;
            }

        }
    }
}
