﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.Enumerations;
using Telerik.WinControls.UI;

namespace RadControlsWinFormsApp.Q22011.Updated
{
    public partial class A_UpdatedControls : Telerik.WinControls.UI.RadForm
    {
        public A_UpdatedControls()
        {
            InitializeComponent();
            radPropertyGrid1.SelectedObject = mebDemo1;
        }

        private void SelectedControl_ToggleStateChanged(object sender, Telerik.WinControls.UI.StateChangedEventArgs args)
        {
            RadRadioButton variable = (sender as RadRadioButton);
            radPropertyGrid1.SelectedObject = radGroupBox1.Controls[variable.Tag.ToString()];
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            Font headerFont = new Font("Arial", 9.0f, FontStyle.Bold);
            Font datesFont = new Font("Arial", 9.0f, FontStyle.Italic);
            RadDateTimePickerCalendar calendarBehavior = this.dtpDemo1.DateTimePickerElement.GetCurrentBehavior() as RadDateTimePickerCalendar;
            RadCalendar calendar = calendarBehavior.Calendar as RadCalendar;
            RadCalendarElement calendarElement = calendar.CalendarElement as RadCalendarElement;
            calendarElement.CalendarNavigationElement.Font = headerFont;
            calendarElement.CalendarNavigationElement.ForeColor = Color.Yellow;
            calendarElement.CalendarNavigationElement.BackColor = Color.White;
            calendarElement.CalendarNavigationElement.BackColor2 = Color.Gray;
            calendarElement.CalendarNavigationElement.BackColor3 = Color.DarkGray;
            calendarElement.CalendarNavigationElement.BackColor4 = Color.Gainsboro;
            calendarElement.CalendarNavigationElement.BorderColor = Color.DarkGray;
            MonthViewElement monthView = calendarBehavior.Calendar.CalendarElement.CalendarVisualElement as MonthViewElement;
            foreach (RadItem item in monthView.TableElement.Children)
            {
                item.Font = datesFont;
            }
        }

        private void radCheckBox1_ToggleStateChanged(object sender, StateChangedEventArgs args)
        {
            if (args.ToggleState == ToggleState.On)
            {
                rwbDemo1.StartWaiting();
            }
            else if (args.ToggleState != ToggleState.On)
            {
                rwbDemo1.StopWaiting();
            }
        }
    }
}