﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using DataAccess;
using Telerik.WinControls;
using Telerik.WinControls.Data;
using Telerik.WinControls.UI;

namespace RadControlsWinFormsApp.Q22011.New
{
    public partial class A_ListViewDemo : Telerik.WinControls.UI.RadForm
    {
        public StoreModelContext _context;

        public A_ListViewDemo()
        {
            InitializeComponent();
            radListViewIcons.ListViewElement.ViewElement.Orientation = Orientation.Horizontal;
            FillIcons();
            _context = new StoreModelContext();
            radListViewData.DataSource = 
            _context.Products.Select(x => new
                                     {
                                         x.CategoryID,
                                         x.ProductID,
                                         x.Category.CategoryName,
                                         x.ModelNumber,
                                         x.ModelName,
                                         x.UnitCost,
                                         x.CurrentPrice,
                                         x.UnitsInStock,
                                         x.Description
                                     }).ToList();
            radListViewData.Columns[0].Visible = false;
            radListViewData.Columns[1].Visible = false;
            radListViewData.EnableGrouping = true;
            radListViewData.ShowGroups = true;
            var groupByValue =
                new GroupDescriptor(
                new SortDescriptor[] {
                    new SortDescriptor(
                        "CategoryName",ListSortDirection.Ascending)
                });
            radListViewData.GroupDescriptors.Add(groupByValue);
            //BindingList<Product> source = 
            //    new BindingList<Product>(_context.Products.ToList());
            //radListViewData.DataSource = source;
        }

        private void FillIcons()
        {
            this.radListViewIcons.ItemSize = new Size(84, 84);
            this.radListViewIcons.ListViewElement.VisualItemFormatting += new ListViewVisualItemEventHandler(ListViewElement_VisualItemFormatting);
            IntPtr hImgSmall;    //the handle to the system image list 
            string fName;        // 'the file name to get icon from
            SHFILEINFO shinfo = new SHFILEINFO();

            this.radListViewIcons.ListViewElement.Items.BeginUpdate();

            foreach (string file in Directory.GetDirectories(@"C:\Windows"))
            {
                DirectoryInfo info = new DirectoryInfo(file);

                fName = info.FullName;

                hImgSmall = Win32.SHGetFileInfo(fName, 0, ref shinfo,
                                                (uint)Marshal.SizeOf(shinfo),
                                                Win32.SHGFI_ICON | Win32.SHGFI_LARGEICON);

                System.Drawing.Icon myIcon =
                System.Drawing.Icon.FromHandle(shinfo.hIcon);

                this.radListViewIcons.ListViewElement.Items.Add(info.Name);
                this.radListViewIcons.ListViewElement.Items[this.radListViewIcons.ListViewElement.Items.Count - 1].Image = myIcon.ToBitmap();
            }

            foreach (string file in Directory.GetFiles(@"C:\Windows"))
            {
                FileInfo info = new FileInfo(file);

                fName = info.FullName;

                hImgSmall = Win32.SHGetFileInfo(fName, 0, ref shinfo,
                                                (uint)Marshal.SizeOf(shinfo),
                                                Win32.SHGFI_ICON | Win32.SHGFI_LARGEICON);

                System.Drawing.Icon myIcon =
                System.Drawing.Icon.FromHandle(shinfo.hIcon);

                this.radListViewIcons.ListViewElement.Items.Add(info.Name);
                this.radListViewIcons.ListViewElement.Items[this.radListViewIcons.ListViewElement.Items.Count - 1].Image = myIcon.ToBitmap();
            }

            this.radListViewIcons.ListViewElement.Items.EndUpdate();
        }

        void ListViewElement_VisualItemFormatting(object sender, ListViewVisualItemEventArgs e)
        {
            e.VisualItem.TextImageRelation = TextImageRelation.ImageAboveText;
        }
    }
}

[StructLayout(LayoutKind.Sequential)]
public struct SHFILEINFO
{
    public IntPtr hIcon;
    public IntPtr iIcon;
    public uint dwAttributes;
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
    public string szDisplayName;
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 80)]
    public string szTypeName;
}

class Win32
{
    public const uint SHGFI_ICON = 0x100;
    public const uint SHGFI_LARGEICON = 0x0;    // 'Large icon
    public const uint SHGFI_SMALLICON = 0x1;    // 'Small icon

    [DllImport("shell32.dll")]
    public static extern IntPtr SHGetFileInfo(string pszPath,
                                              uint dwFileAttributes,
                                              ref SHFILEINFO psfi,
                                              uint cbSizeFileInfo,
                                              uint uFlags);
}